<?php
/**
 * Home Construction Builder functions and definitions
 * @package Home Construction Builder
 */

if ( ! function_exists( 'home_construction_builder_after_theme_support' ) ) :

	function home_construction_builder_after_theme_support() {
		
		add_theme_support( 'automatic-feed-links' );

		add_theme_support('woocommerce');
        add_theme_support('wc-product-gallery-zoom');
        add_theme_support('wc-product-gallery-lightbox');
        add_theme_support('wc-product-gallery-slider');
        add_theme_support('woocommerce', array(
            'gallery_thumbnail_image_width' => 300,
        ));

        load_theme_textdomain( 'home-construction-builder', get_template_directory() . '/languages' );

		add_theme_support(
			'custom-background',
			array(
				'default-color' => 'ffffff',
			)
		);

		$GLOBALS['content_width'] = apply_filters( 'home_construction_builder_content_width', 1140 );
		
		add_theme_support( 'post-thumbnails' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 270,
				'width'       => 90,
				'flex-height' => true,
				'flex-width'  => true,
			)
		);
		
		add_theme_support( 'title-tag' );

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'script',
				'style',
			)
		);

		add_theme_support( 'post-formats', array(
			'video',  
			'audio',  
			'gallery',
			'quote',  
			'image',  
			'link',   
			'status', 
			'aside',  
			'chat',   
		) );
		
		add_theme_support( 'align-wide' );
		add_theme_support( 'responsive-embeds' );
		add_theme_support( 'wp-block-styles' );

		require get_template_directory() . '/inc/metabox.php';
		require get_template_directory() . '/inc/homepage-setup/homepage-setup-settings.php';

		if (! defined( 'HOME_CONSTRUCTION_BUILDER_DOCS_PRO' ) ){
		define('HOME_CONSTRUCTION_BUILDER_DOCS_PRO',__('https://layout.omegathemes.com/steps/pro-home-construction-builder/','home-construction-builder'));
		}
		if (! defined( 'HOME_CONSTRUCTION_BUILDER_BUY_NOW' ) ){
		define('HOME_CONSTRUCTION_BUILDER_BUY_NOW',__('https://www.omegathemes.com/products/home-construction-wordpress-theme','home-construction-builder'));
		}
		if (! defined( 'HOME_CONSTRUCTION_BUILDER_SUPPORT_FREE' ) ){
		define('HOME_CONSTRUCTION_BUILDER_SUPPORT_FREE',__('https://wordpress.org/support/theme/home-construction-builder/','home-construction-builder'));
		}
		if (! defined( 'HOME_CONSTRUCTION_BUILDER_REVIEW_FREE' ) ){
		define('HOME_CONSTRUCTION_BUILDER_REVIEW_FREE',__('https://wordpress.org/support/theme/home-construction-builder/reviews/#new-post','home-construction-builder'));
		}
		if (! defined( 'HOME_CONSTRUCTION_BUILDER_DEMO_PRO' ) ){
		define('HOME_CONSTRUCTION_BUILDER_DEMO_PRO',__('https://layout.omegathemes.com/home-construction-builder/','home-construction-builder'));
		}
		if (! defined( 'HOME_CONSTRUCTION_BUILDER_LITE_DOCS_PRO' ) ){
		define('HOME_CONSTRUCTION_BUILDER_LITE_DOCS_PRO',__('https://layout.omegathemes.com/steps/free-home-construction-builder/','home-construction-builder'));
		}
		if (! defined( 'HOME_CONSTRUCTION_BUILDER_BUNDLE_BUTTON' ) ){
			define('HOME_CONSTRUCTION_BUILDER_BUNDLE_BUTTON',__('https://www.omegathemes.com/products/wp-theme-bundle','home-construction-builder'));
		}

	}

endif;

add_action( 'after_setup_theme', 'home_construction_builder_after_theme_support' );

/**
 * Register and Enqueue Styles.
 */
function home_construction_builder_register_styles() {

	wp_enqueue_style( 'dashicons' );

    $home_construction_builder_theme_version = wp_get_theme()->get( 'Version' );
	$home_construction_builder_fonts_url = home_construction_builder_fonts_url();
    if( $home_construction_builder_fonts_url ){
    	require_once get_theme_file_path( 'lib/custom/css/wptt-webfont-loader.php' );
        wp_enqueue_style(
			'home-construction-builder-google-fonts',
			home_construction_builder_wptt_get_webfont_url( $home_construction_builder_fonts_url ),
			array(),
			$home_construction_builder_theme_version
		);
    }

    wp_enqueue_style( 'swiper', get_template_directory_uri() . '/lib/swiper/css/swiper-bundle.min.css');
    wp_enqueue_style( 'owl.carousel', get_template_directory_uri() . '/lib/custom/css/owl.carousel.min.css');
	wp_enqueue_style( 'home-construction-builder-style', get_stylesheet_uri(), array(), $home_construction_builder_theme_version );

	wp_enqueue_style( 'home-construction-builder-style', get_stylesheet_uri() );
	require get_parent_theme_file_path( '/custom_css.php' );
	wp_add_inline_style( 'home-construction-builder-style',$home_construction_builder_custom_css );

	$home_construction_builder_css = '';

	if ( get_header_image() ) :

		$home_construction_builder_css .=  '
			.header-box{
				background-image: url('.esc_url(get_header_image()).') !important;
				-webkit-background-size: cover !important;
				-moz-background-size: cover !important;
				-o-background-size: cover !important;
				background-size: cover !important;
			}';

	endif;

	wp_add_inline_style( 'home-construction-builder-style', $home_construction_builder_css );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}	

	wp_enqueue_script( 'imagesloaded' );
    wp_enqueue_script( 'masonry' );
	wp_enqueue_script( 'swiper', get_template_directory_uri() . '/lib/swiper/js/swiper-bundle.min.js', array('jquery'), '', 1);
	wp_enqueue_script( 'home-construction-builder-custom', get_template_directory_uri() . '/lib/custom/js/theme-custom-script.js', array('jquery'), '', 1);
	wp_enqueue_script( 'owl.carousel', get_template_directory_uri() . '/lib/custom/js/owl.carousel.js', array('jquery'), '', 1);

    // Global Query
    if( is_front_page() ){

    	$home_construction_builder_posts_per_page = absint( get_option('posts_per_page') );
        $home_construction_builder_c_paged = ( get_query_var( 'page' ) ) ? absint( get_query_var( 'page' ) ) : 1;
        $home_construction_builder_posts_args = array(
            'posts_per_page'        => $home_construction_builder_posts_per_page,
            'paged'                 => $home_construction_builder_c_paged,
        );
        $home_construction_builder_posts_qry = new WP_Query( $home_construction_builder_posts_args );
        $home_construction_builder_max = $home_construction_builder_posts_qry->max_num_pages;

    }else{
        global $wp_query;
        $home_construction_builder_max = $wp_query->max_num_pages;
        $home_construction_builder_c_paged = ( get_query_var( 'paged' ) > 1 ) ? get_query_var( 'paged' ) : 1;
    }

    $home_construction_builder_default = home_construction_builder_get_default_theme_options();
    $home_construction_builder_pagination_layout = get_theme_mod( 'home_construction_builder_pagination_layout',$home_construction_builder_default['home_construction_builder_pagination_layout'] );
}

add_action( 'wp_enqueue_scripts', 'home_construction_builder_register_styles',200 );

function home_construction_builder_admin_enqueue_scripts_callback() {
    if ( ! did_action( 'wp_enqueue_media' ) ) {
    wp_enqueue_media();
    }
    wp_enqueue_script('home-construction-builder-uploaderjs', get_stylesheet_directory_uri() . '/lib/custom/js/uploader.js', array(), "1.0", true);
}
add_action( 'admin_enqueue_scripts', 'home_construction_builder_admin_enqueue_scripts_callback' );

/**
 * Register navigation menus uses wp_nav_menu in five places.
 */
function home_construction_builder_menus() {

	$home_construction_builder_locations = array(
		'home-construction-builder-primary-menu'  => esc_html__( 'Primary Menu', 'home-construction-builder' ),
	);

	register_nav_menus( $home_construction_builder_locations );
}

add_action( 'init', 'home_construction_builder_menus' );

add_filter('loop_shop_columns', 'home_construction_builder_loop_columns');
if (!function_exists('home_construction_builder_loop_columns')) {
	function home_construction_builder_loop_columns() {
		$home_construction_builder_columns = get_theme_mod( 'home_construction_builder_per_columns', 3 );
		return $home_construction_builder_columns;
	}
}

add_filter( 'loop_shop_per_page', 'home_construction_builder_per_page', 20 );
function home_construction_builder_per_page( $home_construction_builder_cols ) {
  	$home_construction_builder_cols = get_theme_mod( 'home_construction_builder_product_per_page', 9 );
	return $home_construction_builder_cols;
}

add_filter( 'woocommerce_output_related_products_args', 'home_construction_builder_products_args' );

function home_construction_builder_products_args( $home_construction_builder_args ) {

    $home_construction_builder_args['posts_per_page'] = get_theme_mod( 'home_construction_builder_custom_related_products_number', 6 );

    $home_construction_builder_args['columns'] = get_theme_mod( 'home_construction_builder_custom_related_products_number_per_row', 3 );

    return $home_construction_builder_args;
}

require get_template_directory() . '/inc/custom-header.php';
require get_template_directory() . '/classes/class-svg-icons.php';
require get_template_directory() . '/classes/class-walker-menu.php';
require get_template_directory() . '/inc/customizer/customizer.php';
require get_template_directory() . '/inc/custom-functions.php';
require get_template_directory() . '/inc/template-tags.php';
require get_template_directory() . '/classes/body-classes.php';
require get_template_directory() . '/inc/widgets/widgets.php';
require get_template_directory() . '/inc/pagination.php';
require get_template_directory() . '/lib/breadcrumbs/breadcrumbs.php';
require get_template_directory() . '/lib/custom/css/dynamic-style.php';


function home_construction_builder_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'home_construction_builder_remove_customize_register', 11 );

// Apply styles based on customizer settings


function home_construction_builder_radio_sanitize(  $home_construction_builder_input, $home_construction_builder_setting  ) {
	$home_construction_builder_input = sanitize_key( $home_construction_builder_input );
	$home_construction_builder_choices = $home_construction_builder_setting->manager->get_control( $home_construction_builder_setting->id )->choices;
	return ( array_key_exists( $home_construction_builder_input, $home_construction_builder_choices ) ? $home_construction_builder_input : $home_construction_builder_setting->default );
}
require get_template_directory() . '/inc/general.php';


// NOTICE FUNCTION

function home_construction_builder_admin_notice() { 
    global $pagenow;
    $theme_args = wp_get_theme();
    $meta = get_option( 'home_construction_builder_admin_notice' );
    $name = $theme_args->get( 'Name' );
    $current_screen = get_current_screen();

    if ( ! $meta ) {
        if ( is_network_admin() ) {
            return;
        }

        if ( ! current_user_can( 'manage_options' ) ) {
            return;
        }

        if ( $current_screen->base != 'appearance_page_homeconstructionbuilder-wizard' ) {
            ?>
            <div class="notice notice-success notice-content">
                <h2><?php esc_html_e('Welcome! Thank you for choosing Home Construction Builder. Let’s Set Up Your Website!', 'home-construction-builder') ?> </h2>
                <p><?php esc_html_e('Before you dive into customization, let’s go through a quick setup process to ensure everything runs smoothly. Click below to start setting up your website in minutes!', 'home-construction-builder') ?> </p>
                <div class="info-link">
                    <a href="<?php echo esc_url( admin_url( 'themes.php?page=homeconstructionbuilder-wizard' ) ); ?>"><?php esc_html_e('Get Started with Home Construction Builder', 'home-construction-builder'); ?></a>
                </div>
                <p class="dismiss-link"><strong><a href="?home_construction_builder_admin_notice=1"><?php esc_html_e( 'Dismiss', 'home-construction-builder' ); ?></a></strong></p>
            </div>
            <?php
        }
    }
}
add_action( 'admin_notices', 'home_construction_builder_admin_notice' );

if ( ! function_exists( 'home_construction_builder_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
 */
function home_construction_builder_update_admin_notice() {
    if ( isset( $_GET['home_construction_builder_admin_notice'] ) && $_GET['home_construction_builder_admin_notice'] == '1' ) {
        update_option( 'home_construction_builder_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'home_construction_builder_update_admin_notice' );

// After Switch theme function
add_action( 'after_switch_theme', 'home_construction_builder_getstart_setup_options' );
function home_construction_builder_getstart_setup_options() {
    update_option( 'home_construction_builder_admin_notice', false );
}